<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Auth;

class Fund extends Model
{
    use HasFactory;

    protected $table = "users";

    protected $guarded = ['id'];
    const OBJECT_TYPE = 'fund';

    protected $appends = [
        'paid_fund_value'
    ];

    protected static function boot()
    {
        parent::boot(); // TODO: Change the autogenerated stub
        static::addGlobalScope('branch', function (Builder $builder) {
            $builder->where('branch', Auth::user()->{'branch'});
        });

        static::addGlobalScope('has_fund', function (Builder $builder) {
            $builder->whereIn('role', [User::SUPPORTER_ROLE, User::TEACHER_ROLE, User::STAFF_ROLE]);
        });
    }

    public function getPaidFundValueAttribute(): int
    {
        return Transaction::query()->where('object_type', Fund::OBJECT_TYPE)->where('object_id', $this->id)->sum('amount');
    }
}
